/***
 * Portable GUI
 * Code for HelloWorld
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <portablegui.h> // Import all PortableGUI include files

class MyWindowListener : public PGWindowListener {
	
	virtual void windowClosing(PGWindow* wnd);
};

void MyWindowListener::windowClosing(PGWindow* wnd) {
	getPGApplication()->exit(0); // Exit the application
}

PGMAINPROC { // Mainproc is different for Windows and GTK
	PGApplication app;

	PGINIT(app); // Initialize the app using Mainproc args

	PGFrame frame("PortableGUI - HelloWorld"); // Create new frame window

	MyWindowListener* wl = new MyWindowListener();	// Create window listener for frame
	frame.addWindowListener(wl); // Add window listener to frame
	
	frame.pack(); // Use layout manager
	frame.setVisible(TRUE); // Show the frame

	return app.run(); // Main event loop
}
