/***
 * Portable GUI
 * Code for MkHeader
 * Copyright (C) 2001-2001 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

// Import all PortableGUI include files
#include <portablegui.h>
#include <pgio/pginputstream.h>
#include <pgio/pgoutputstream.h>
#include <pgio/pgfileinputstream.h>
#include <pgio/pgfileoutputstream.h>

// Mainproc is different for Windows and GTK
PGMAINPROC {
	long bytes = 0;
	boolean first = true;	
	PGString str, hex;
	PGApplication app;
	// Initialize the app using Mainproc args
	PGINIT(app);
	// Filename
	PGString fname = app.getCmdLine();
	PGString mainname = fname;
	int dot = fname.lastIndexOf('.');
	if (dot > 1) mainname.substring(0, dot-1);
	// Load input file	
	PGFileInputStream input(fname);
	PGFileOutputStream output(mainname + STR(".h"));
	output.println(STR("const char ") + mainname + STR("[] = {"));	
	int ch = input.read();
	while (ch != -1) {
		if (ch < 0x10) {
			if (first) hex.format("\t0x0%X", ch);
			else hex.format(", 0x0%X", ch);			
		} else {
			if (first) hex.format("\t0x%X", ch);
			else hex.format(", 0x%X", ch);
		}
		str.append(hex);
		ch = input.read();
		bytes++; 		
		if ((bytes % 20) == 0) {
			first = true;
			if (ch != -1) output.println(str + STR(","));
			else output.println(str);
			str = "";
		} else {
			first = false;
		}		
	}
	if (!first) output.println(str);
	output.println("};");
	output.close();
	input.close();
	return 0;
}
