/***
 * Portable GUI
 * Code for PGActionListener
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#ifndef _PGACTIONLISTENER_
#define _PGACTIONLISTENER_

#include <pgutil/pglinkedlist.h>

class PGActionListenerParent;
 
class PGActionListener : public PGListElement {

public:
	virtual ~PGActionListener();
	// Convert to string representation
	virtual void toString(PGString* str);
	// Invoked when window activated
	virtual void actionPerformed(PGActionListenerParent* from) = 0;
};
 
class PGActionListenerParent : public PGAbstractLinkedList {
public:
	virtual ~PGActionListenerParent();
	virtual void onAction();
	virtual void onSelect();
	void addActionListener(PGActionListener* action);
	void removeActionListener(PGActionListener* action);
};

#endif
