/***
 * Portable GUI
 * Code for PGImageViewer
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#ifndef _PGANIMATEDIMGVIEWER_
#define _PGANIMATEDIMGVIEWER_

#include <pgutil/pgtimer.h>
#include <pgcomponent/pgcanvas.h>

class PGAnimatedImageViewer : public PGCanvas, PGTimer {
public:
	PGImage m_hBuffer;
	int m_iCrFrame, m_iSpeed, m_iLoop, m_iWidth, m_iHeight;
	BOOL m_bFirstTime, m_bAnimationBusy;
	PGAnimatedImage* m_hImage;
public:
	PGAnimatedImageViewer(PGAnimatedImage* image);
	PGAnimatedImageViewer(int w, int h, PGWindow* owner);
	void setImage(PGAnimatedImage* image);
	virtual ~PGAnimatedImageViewer();
	virtual void paint(PGGraphics* graph);
	virtual void getPreferredSize(PGDimension* dimension, BOOL recalc);
	virtual void tick();
	virtual void showFrame(int idx);
	virtual void disposeFrame(int idx);	
	virtual void gotoFrame(int idx);	
	void reset();
	void initialframe();
	void startAnimation();
	void stopAnimation();
	void showNextFrame(BOOL skipZeroDelay);
	PGAnimatedImageFrame* getFrame();
	int getNbFrames();
	int getNbLoops();
	void init();	
}; 
 
#endif
