/***
 * Portable GUI
 * Code for PGCanvas
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#ifndef _PGCANVAS_
#define _PGCANVAS_

#include <pgcomponent/pgnormalcomponent.h>
#include <pgcomponent/pgmouselistener.h>
#include <pgdraw/pgimage.h>

class PGCanvas : public PGNormalComponent, public PGMouseListenerParent {
public:
	virtual void toString(PGString* strg);	
	virtual void getPreferredSize(PGDimension* dimension, BOOL recalc);
	virtual void addToWindow(PGWindow* parent);
	virtual void removeFromWindow(PGWindow* parent);	
	virtual void setBounds(int x, int y, int w, int h);
};

class PGDoubleBufferCanvas : public PGCanvas {
public:
	PGImage m_hBufferImage;
public:	
	virtual ~PGDoubleBufferCanvas();
	virtual void setBounds(int x, int y, int w, int h);
	virtual void paint(PGGraphics* graph);
	virtual void draw(PGGraphics* graph) = 0;
	PGGraphics* getBufferGraphics();		
	void redraw(int x, int y, int w, int h, PGGraphics *graph);
	void redraw(int x, int y, int w, int h);	
};
 
#endif
