/***
 * Portable GUI
 * Code for PGContainer
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#ifndef _PGCONTAINER_
#define _PGCONTAINER_

#include <pgcomponent/pgcomponent.h> 
#include <pgutil/pgvector.h> 

class PGWindow;
class PGLayoutManager;
 
class PGContainer : public PGComponent {
private:
	PGLayoutManager* m_pLayoutManager;
	PGVector m_vComponents;	
public:
	PGContainer();
	~PGContainer();
// Layout
	void setLayout(PGLayoutManager* layout);
	virtual void getPreferredSize(PGDimension* dimension, BOOL recalc);
	virtual void setLayoutSize(PGRectangle* rectangle);
	virtual void setVisible(BOOL visible);
	virtual PGWindow* getWindow();
	virtual void addToWindow(PGWindow* parent);
	virtual void removeFromWindow(PGWindow* parent);	
#ifndef PGTINY	
	virtual void setStyle(PGStyle* style);	
#endif	
// Component retrieval
	void add(PGComponent* comp);
	void add(PGComponent* comp, int idx);
	void remove(PGComponent* comp);
	PGComponent* getComponentAt(int idx);
	int getComponentCount();
};
 
#endif
