/***
 * Portable GUI
 * Code for PGButton
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#ifndef _PGLABEL_
#define _PGLABEL_

#define PGLABEL_CENTER 512
#define PGLABEL_LEFT   1024
#define PGLABEL_RIGHT  2048
#define PGLABEL_SUNKEN 4096
 
class PGLabel : public PGNormalComponent, public PGTextDisplay {
public:
	#ifdef PGGTK
		GtkWidget* m_hLabel;
	#endif

	PGString m_sLabel;	
public:
	PGLabel(const char *text);
	PGLabel(const char *text, PGStyle* style);
	PGLabel(const char *text, int flags);
	virtual void toString(PGString* strg);
	virtual void getPreferredSize(PGDimension* dimension, BOOL recalc);
	virtual void addToWindow(PGWindow* parent);
	virtual void removeFromWindow(PGWindow* parent);
	virtual void setText(const char* str);
	virtual void changeFlags(int orval, int andval);

#ifdef PGGTK
	virtual GtkWidget* getWidget();
#endif
	
private:
	void init(const char* text, int justify);
};
 
#endif
