/***
 * Portable GUI
 * Code for PGNormalComponent
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#ifndef _PGNORMALCOMPONENT_
#define _PGNORMALCOMPONENT_

class PGFont;
class PGStyle;

class PGNormalComponent : public PGComponent {

	#ifdef PGWIN
		#include <pgdep/win/pgwincomp.h>
	#endif

	#ifdef PGGTK
		#include <pgdep/gtk/pggtkcomp.h>
	#endif
	
	#ifdef PGBEOS
		#include <pgdep/beos/pgbeoscomp.h>
	#endif
	
public:
	PGNormalComponent();
	virtual void addToWindow(PGWindow* parent);
	virtual void setVisible(BOOL visible);
	virtual void setBounds(int x, int y, int w, int h);
	virtual void getBounds(PGRectangle* rectangle);
	virtual void getSize(PGDimension* size);
	virtual void setStyle(PGStyle* style);	
	virtual void requestFocus();
	virtual void repaint();	
	virtual void repaint(PGRectangle* rectangle);	
	virtual void getGraphics(PGGraphics *graph);
	virtual void createImage(int w, int h, PGImage* img);	
	virtual void changeFlags(int orval, int andval);	

#ifdef PGGTK
	virtual GtkWidget* getWidget();
#endif
	
};
 
#endif
