
/* GTK - The GIMP Toolkit
 * Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/*
 * Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
 * file for a list of people on the GTK+ Team.  See the ChangeLog
 * files for a list of changes.  These files are distributed with
 * GTK+ at ftp://ftp.gtk.org/pub/gtk/.
 */

#ifndef _PGGTKLAYOBOX_
#define _PGGTKLAYOBOX_

#include <gdk/gdk.h>

#ifdef __cplusplus
extern "C" {
#endif

#define PG_GTK_TYPE_LAYOBOX		(pg_gtk_layobox_get_type ())
#define PG_GTK_LAYOBOX(obj)		(GTK_CHECK_CAST ((obj), PG_GTK_TYPE_LAYOBOX, PGGtkLayobox))
#define PG_GTK_LAYOBOX_CLASS(klass)	(GTK_CHECK_CLASS_CAST ((klass), GTK_TYPE_LAYOBOX, PGGtkLayoboxClass))
#define PG_GTK_IS_LAYOBOX(obj)	 	(GTK_CHECK_TYPE ((obj), PG_GTK_TYPE_LAYOBOX))
#define PG_GTK_IS_LAYOBOX_CLASS(klass)  (GTK_CHECK_CLASS_TYPE ((klass), GTK_TYPE_LAYOBOX))

typedef struct _PGGtkLayobox	   PGGtkLayobox;
typedef struct _PGGtkLayoboxClass  PGGtkLayoboxClass;

class PGContainer;

struct _PGGtkLayobox
{
  GtkContainer container;
  GList *children;
  PGContainer *pgcontainer;
};

struct _PGGtkLayoboxClass
{
  GtkContainerClass parent_class;
};

GtkType	pg_gtk_layobox_get_type(void);
GtkWidget* pg_gtk_layobox_new();
void pg_gtk_layobox_set_pgcontainer(PGGtkLayobox *layobox, PGContainer *container);
void pg_gtk_layobox_append(GtkContainer *container, GtkWidget *child);
void pg_gtk_layobox_delete(GtkContainer *container, GtkWidget *widget);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
