/***
 * Portable GUI
 * Code for PGFileDialog
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#ifndef _PGFILEDIALOG_
#define _PGFILEDIALOG_

#define PGFILEDIALOG_MAXFILENAME 300

class PGFileDialog {

	#ifdef PGGTK
		#include <pgdep/gtk/pggtkcont.h>
	#endif

public:
	PGString m_sFile;
	PGString m_sDirectory;
	PGString m_sTitle;
	PGString m_sFilter;
	BOOL	 m_bUseDirectory;
	BOOL	 m_bWasOK;
public:
	PGFileDialog(const char* title);
	void setTitle(const char* title);
	void setDirectory(const char* directory);
	void setFilter(const char* filter);
	void setFile(const char* file);
	BOOL showFileOpenDialog(PGWindow* parent);
	BOOL showFileSaveDialog(PGWindow* parent);
};

#endif
