/***
 * Portable GUI
 * Code for PGColor
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef _PGCOLOR_
#define _PGCOLOR_

#include <pgio/pginputstream.h>

#define PGCOLOR_BLACK		&PGColorBlack
#define PGCOLOR_BLUE		&PGColorblue
#define PGCOLOR_CYAN		&PGColorCyan
#define PGCOLOR_DARKGRAY	&PGColorDarkGray
#define PGCOLOR_GRAY		&PGColorGray
#define PGCOLOR_GREEN		&PGColorGreen
#define PGCOLOR_LIGHTGRAY	&PGColorLightGray
#define PGCOLOR_MAGENTA		&PGColorMagenta
#define PGCOLOR_ORANGE		&PGColorOrange
#define PGCOLOR_PINK		&PGColorPink
#define PGCOLOR_RED		&PGColorRed
#define PGCOLOR_WHITE		&PGColorWhite
#define PGCOLOR_YELLOW		&PGColorYellow

class PGColor {
public:
	PGBYTE m_iRed, m_iGreen, m_iBlue;
public:
	PGColor(PGBYTE red = 0, PGBYTE green = 0, PGBYTE blue = 0);
	PGColor(const PGColor* color);
	void setColor(PGBYTE red, PGBYTE green, PGBYTE blue);
	BOOL equals(PGColor* other) const;
	BOOL equals(PGBYTE red, PGBYTE green, PGBYTE blue) const;
	unsigned long getBGR();
	unsigned long getRGB();
	void setCopyValue(const PGColor* other);
	void darker(PGColor* nc);
	void brighter(PGColor* nc);
	BOOL read(PGInputStream* input);
	PGColor & operator=(const PGColor &color);
};

extern PGColor PGColorBlack;
extern PGColor PGColorblue;
extern PGColor PGColorCyan;
extern PGColor PGColorDarkGray;
extern PGColor PGColorGray;
extern PGColor PGColorGreen;
extern PGColor PGColorLightGray;
extern PGColor PGColorMagenta;
extern PGColor PGColorOrange;
extern PGColor PGColorPink;
extern PGColor PGColorRed;
extern PGColor PGColorWhite;
extern PGColor PGColorYellow;

#endif
