/***
 * Portable GUI
 * Code for PGNormalComponent
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#ifndef _PGFONT_
#define _PGFONT_

#define PGFONT_PLAIN		0
#define PGFONT_BOLD		1
#define PGFONT_ITALIC		2
#define PGFONT_UNDERLINE	4
#define PGFONT_STRIKEOUT	8

// Internals
#define PGFONT_REALIZED		16
#define PGFONT_ALL		0xFFF

class PGWindow;
 
class PGFont : public PGObject {
public:
	PGString m_sName;
	int m_iFlags;
	int m_iSize;
public:
	PGFont(const char *name, int style, int size);
	void getStringRepresentation(PGString* fontstr);
	BOOL equals(PGFont* font);
	virtual ~PGFont();
	virtual void toString(PGString* str);
};

class PGRealizedFont : public PGObject {
	
	#ifdef PGWIN
		#include <pgdep/win/pgwinfont.h>
	#endif

	#ifdef PGGTK
		#include <pgdep/gtk/pggtkfont.h>
	#endif

public:
	PGFont* m_hFont;
public:
	PGRealizedFont(PGFont* font);
	~PGRealizedFont();
	void realize(PGWindow* window);
	void unrealize();
};
 
#endif
