/***
 * Portable GUI
 * Code for PGNormalComponent
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#ifndef _PGFONTMETRICS_
#define _PGFONTMETRICS_

class PGGraphics;

class PGFontMetrics {
private:
	int m_iAscent, m_iDescent, m_iMaxAscent, m_iMaxDescent;
	int m_iHeight, m_iLeading, m_iMaxAdvance;
public:
	PGGraphics* m_hGraphics;
public:
	void getStringSize(PGString* str, PGDimension* dim);
	// Determines the font ascent
        int getAscent();
	// Determines the font descent
        int getDescent();
	// Gets the standard height of a line of text
	int getHeight();
	// Determines the standard leading
        int getLeading();
	// Gets the maximum advance width of any character
        int getMaxAdvance();
	// Determines the maximum ascent
        int getMaxAscent();
        // Determines the maximum descent
        int getMaxDescent();
        // Returns the total advance width for showing the specified String
        int stringWidth(PGString* str);
        // Internal
        void realize();
};
 
#endif
