/***
 * Portable GUI
 * Code for PGShape
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#ifndef _PGSHAPE_
#define _PGSHAPE_

#include <pgmain/pgmain.h>
#include <pgmain/pgmath.h>

class PGPolygon : public PGObject {
public:
	#ifdef PGWIN
		POINT* m_hWinPoints;
	#endif	
	
	#ifdef PGGTK
		GdkPoint* m_hGTKPoints;
	#endif		
public:		
	BOOL m_bRealized;
	int* m_iXPoints;
	int* m_iYPoints;
	int  m_iNPoints;
	int  m_iSize;
public:
	PGPolygon();
	PGPolygon(int nPoints);
	PGPolygon(int* xPoints, int* yPoints, int nPoints);
	virtual ~PGPolygon();
	
	// FIXME: Poly must grow	
	void addPoint(int x, int y);
	int getNbPoints();
// Internals
	void realize();
	void unrealize();
	void init();
	void init(int size);	
};
 
#endif
