/***
 * Portable GUI
 * Code for PGInputStream
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#ifndef _PGFILEINPUTSTREAM_
#define _PGFILEINPUTSTREAM_

#include <pgio/pginputstream.h>

class PGFileInputStream : public PGInputStream {
private:
	int m_iError;
	PGString m_sFile;
public:
	FILE* m_hFile;
public:
	PGFileInputStream(const char* fname);
	virtual ~PGFileInputStream();
	// Get error
	virtual int getError();
	// Reads the next byte of data from the input stream
	virtual int read();
	// Reads up to len bytes of data from the input stream into an array of bytes
        virtual int read(unsigned char* buffer, int off, int len);
	// Closes the input file
	void close();
};

 
#endif
