/***
 * Portable GUI
 * Code for PGOutputStream
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#ifndef _PGOUTPUTSTREAM_
#define _PGOUTPUTSTREAM_

#define PGOUTPUTSTREAM_ERROR_NONE	0
#define PGOUTPUTSTREAM_ERROR_OPEN	2

#include <pgmain/pgmain.h>
#include <pgutil/pgstring.h>

class PGOutputStream : public PGObject {
public:
	long m_lPosition;	
public:
	PGOutputStream();
	// Test if error (at end is also error!)
	virtual int getError() = 0;
	// Write the next byte of data to the output stream
	virtual int write(int byte) = 0;
	// Write len bytes of data to the output stream starting from off in the buffer
        virtual int write(const unsigned char* buffer, int off, int len);        
	// Write len bytes of data to the output stream
     	int write(const unsigned char* buffer, int len);
	// Returns current stream position
	long getPosition();
	// Writes one line of text
	void println(const char* str);
	// Write 16 bits LE integer
	void write16LEInt(int data);
	// Write 32 bits LE integer
	void write32LEInt(long data);	
};
 
#endif
