/***
 * Portable GUI
 * Code for PGBorderLayout
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#ifndef _PGBORDERLAYOUT_
#define _PGBORDERLAYOUT_

#define PGBORDERLAYOUT_CENTER 0
#define PGBORDERLAYOUT_NORTH  1
#define PGBORDERLAYOUT_SOUTH  2
#define PGBORDERLAYOUT_WEST   3
#define PGBORDERLAYOUT_EAST   4

class PGBorderLayout : public PGLayoutManager {
public:
	int m_iBorderX, m_iBorderY, m_iSeparatorX, m_iSeparatorY;
	PGBorderLayout();
	PGBorderLayout(int borderX, int borderY, int separatorX, int separatorY);
	PGBorderLayout(int separatorX, int separatorY);	
	virtual void getPreferredSize(PGContainer* container, PGDimension* dimension, BOOL recalc);
	virtual void layoutContainer(PGContainer* container, PGRectangle* rectangle);
protected:
	void getComponentSize(PGComponent* comp, PGDimension* dim, BOOL recalc);
};
 
#endif
