/***
 * Portable GUI
 * Code for PGPercentLayout
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#ifndef _PGPERCENTLAYOUT_
#define _PGPERCENTLAYOUT_

#define PGPERCENTLAYOUT_PERCENT   1
#define PGPERCENTLAYOUT_ABSOLUTE  2
#define PGPERCENTLAYOUT_DUMMY     4
#define PGPERCENTLAYOUT_PREF      8
#define PGPERCENTLAYOUT_LEFT      16
#define PGPERCENTLAYOUT_RIGHT     32
#define PGPERCENTLAYOUT_CENTER    64

#define PGPERCENTLAYOUT_NORTH 1
#define PGPERCENTLAYOUT_EAST  2
#define PGPERCENTLAYOUT_SOUTH 4
#define PGPERCENTLAYOUT_WEST  8
#define PGPERCENTLAYOUT_ALL   PGPERCENTLAYOUT_NORTH | PGPERCENTLAYOUT_SOUTH | PGPERCENTLAYOUT_WEST | PGPERCENTLAYOUT_EAST

class PGPercentLayout : public PGLayoutManager {
private:
	int m_iBorderSize, m_iSides, m_iNum, m_iDummies, m_iPreferredWidth, m_iPreferredHeight;
	BOOL m_bVert, m_bSizeUnknown;
	int *m_aModes, *m_aSizes;
public:
	PGPercentLayout(char* desc, int gap, int sides, BOOL vert);
	virtual void getPreferredSize(PGContainer* container, PGDimension* dimension, BOOL recalc);
	virtual void layoutContainer(PGContainer* container, PGRectangle* rectangle);
protected:
	void setSizes(PGContainer* parent, BOOL recalc);
};
 
#endif
