/***
 * Portable GUI
 * Code for PGApplication
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#ifndef _PGAPPLICATION_
#define _PGAPPLICATION_
 
#include <pgmain/pgmain.h>
#include <pgutil/pgvector.h>

#ifndef PGTINY
	#ifdef PGWIN
		#include <pgdep/win/pgcommandlist.h>
	#endif
#endif
 
class PGApplication : public PGObject {

	#ifdef PGWIN
		#include <pgdep/win/pgwinapp.h>
	#endif
	
	#ifdef PGGTK
		#include <pgdep/gtk/pggtkapp.h>
	#endif
	
	#ifdef PGBEOS
		#include <pgdep/beos/pgbeosapp.h>
	#endif	

	#ifdef PGCE
		#include <pgdep/win/pgwinapp.h>
	#endif
		
public:
	BOOL m_bConsoleEnabled;
	PGString m_sStartDir;
	PGString m_sCmdLine;
public:
// Public methods
	PGApplication();
	~PGApplication();
	virtual void toString(PGString* str);
	void error(const char* strg);
	void println(const char* strg);	
	void printf(const char* format, ...);
	void setConsoleEnabled(BOOL enable);
	const char* getStartDirectory();
	const char* getCmdLine();
	int run();
	void exit(int code);	
};

PGApplication *getPGApplication();
void setPGApplication(PGApplication *app);

#endif
