/***
 * Portable GUI
 * Code for PortableGUI
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#ifndef _PGMAIN_
#define _PGMAIN_

#define PGVERSION     "0.01"
#define PGSTRLEN      100
#define PGMAXSTRLEN   255
#define PGFILENAMELEN 255

#define PGBYTE unsigned char
#define PGWORD unsigned int
#define PGDWORD unsigned long

#define PGCR '\r'
#define PGLF '\n'

#define MAX2(a,b) a > b ? a : b
#define MIN2(a,b) a < b ? a : b

#ifdef PGWIN
	#define PGVISUALC
	#include <pgdep/win/pgwin.h>
#endif

#ifdef PGGTK
	#define PGGCC
	#include <pgdep/gtk/pggtk.h>
#endif

#ifdef PGBEOS
	#define PGGCC
	#include <pgdep/beos/pgbeos.h>
#endif

#ifdef PGCE
	#define PGVISUALC
	#include <pgdep/wince/pgce.h>
#endif

#define extends : public
#define boolean BOOL
#define true TRUE
#define false FALSE
#define null NULL

typedef void* PGVoidPtr;
typedef char* PGCharPtr;

typedef struct {
	int width;
	int height;
} PGDimension;

typedef struct {
	int x;
	int y;
} PGPoint;

class PGRectangle {
public:
	int x;
	int y;
	int width;
	int height;
public:
	void fromPoints(int x1, int y1, int x2, int y2);
};

class PGCallback {
public:
	virtual ~PGCallback();
	virtual void callback(void *info) = 0;
};

class PGTextDisplay {
public:
	virtual void setText(const char* str) = 0;
};

#include <pgutil/pgobject.h>

#endif
