
#ifndef _PGCOLLECTION_
#define _PGCOLLECTION_

#include <pgmain/pgmain.h>

class PGCollection;

class PGIterator {
protected:
	PGCollection* m_hCollection;
	PGObject* m_hCurrent;
	int m_iIndex;
public: 
	PGIterator(PGCollection* collection, PGObject* first);
	virtual ~PGIterator();

	// Returns true if the iteration has more elements.
	boolean hasNext() const;
                  
	// Returns the next element in the interation.
	PGObject* next();

	// Removes from the underlying collection the last element returned by the iterator                  
	void remove();
};

class PGCollection {
public:
	// Ensures that this collection contains the specified element
	virtual boolean add(PGObject* o) = 0;

	// Adds all of the elements in the specified collection to this collection
	// virtual boolean addAll(PGAbstractCollection* c);

	// Removes all of the elements from this collection
	virtual void clear() = 0;
                    
	// Returns true if this collection contains the specified element.		    
	// virtual boolean contains(PGObject* o);

	// Returns true if this collection contains all of the elements in the specified collection.
	// virtual boolean containsAll(PGAbstractCollection* c);
	
	// Returns true if this collection contains no elements.
	// virtual boolean isEmpty();

	// Returns an iterator over the elements contained in this collection.                    
	virtual PGIterator iterator() = 0;

	// Removes a single instance of the specified element from this collection.
	// virtual boolean remove(Object* o);

	// Removes from this collection all of its elements that are contained in the specified collection
	// virtual boolean removeAll(PGCollection* c):

	// Retains only the elements in this collection that are contained in the specified collection
	// virtual boolean retainAll(PGCollection* c);

	// Returns the number of elements in this collection.
	// virtual int size();
                    
	// Returns an array containing all of the elements in this collection.    
	// virtual PGObject* toArray();

	// Compares the specified object with this collection for equality.                    
	// virtual boolean equals(PGObject* o);

	// Returns the hash code value for this collection.
	// virtual int hashCode();

protected:	
	virtual boolean hasNext(int idx, PGObject* obj) const = 0;
	virtual PGObject* next(int idx, PGObject* obj) const = 0;
	friend class PGIterator;
};

#endif
