
#ifndef _PGLINKEDLIST_
#define _PGLINKEDLIST_

#include <pgutil/pgcollection.h>

class PGListElement : public PGObject {
protected:
	PGListElement* m_hNextElement;
public:
	PGListElement();
	PGListElement* getNextElement() const;
	void setNextElement(PGListElement* elem);
};

 
class PGAbstractLinkedList : public PGCollection {
protected:
	PGListElement *m_hFirstElement;
	PGListElement *m_hLastElement;	
public:
	PGAbstractLinkedList();
	virtual ~PGAbstractLinkedList();	
	// Ensures that this collection contains the specified element
	virtual boolean add(PGObject* o); 
	// Removes all of the elements from this collection
	virtual void clear();
	// Inserts the given element at the beginning of this list.
	void addFirst(PGObject* o);           
	// Appends the given element to the end of this list.        
        void addLast(PGObject* o);
	// Returns an iterator over the elements contained in this collection.                    
	PGListElement* getFirst() const;
	virtual PGIterator iterator();	
protected:
	virtual boolean hasNext(int idx, PGObject* obj) const;
	virtual PGObject* next(int idx, PGObject* obj) const;	
};

#endif
