
#ifndef _PGLIST_
#define _PGLIST_

class PGListElement : public PGObject {
protected:
	PGListElement* m_hNextElement;
public:
	PGListElement* getNextElement() const {
		return m_hNextElement;
	};
	void setNextElement(PGListElement* elem);
};

 
class PGList : public PGObject {
protected:
	void **m_pArray;
	long m_iSize, m_iGrow, m_iArrSize;
	BOOL m_bDoCleanUp;
public:
	PGVector();
	PGVector(long size, long grow);
	virtual ~PGVector();
	virtual void toString(PGString* str);
	long getSize();
	void setGrow(long grow);
	void* getElementAt(long idx);
	void addElement(void* element);
	void removeElement(void* element);
	void setElementAt(void* element, long idx);
	void removeElementAt(long idx);
	void removeElements(long first, long last);
	void removeAll();
	long indexOfReference(void* element);
	void setDoCleanUp(BOOL yesNo);
private:
	void init(long size, long grow);
	void shrink();
	void grow();
	void deleteAll();
};

#endif
