/***
 * Portable GUI
 * Code for PGTimer
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef _PGTIMER_
#define _PGTIMER_

#include <pgwindow/pgwindow.h>

class PGTimer : public PGObject {
public:
	PGWindow* m_hOwner;
	long m_iDelay;
public:

#ifdef PGWIN
	int m_iId;
#endif

#ifdef PGGTK
	gint m_iTimerTag;
#endif

public:
	PGTimer(PGWindow* owner);
	virtual ~PGTimer();
	virtual void tick() = 0;
	void startTimer(long delay);
	void stopTimer();
	void init();
	void term();
	BOOL isRunning();
};

#ifdef PGWIN
	void PGTimerTick(PGTimer* timer);
#endif

#endif

