/***
 * Portable GUI
 * Code for PGVector
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef _PGVECTOR_
#define _PGVECTOR_

class PGVector : public PGObject {
protected:
	void **m_pArray;
	long m_iSize, m_iGrow, m_iArrSize;
	BOOL m_bDoCleanUp;
public:
	PGVector();
	PGVector(long size, long grow);
	virtual ~PGVector();
	virtual void toString(PGString* str);
	long getSize();
	boolean empty();
	void setGrow(long grow);
	void* getElementAt(long idx);
	void addElement(void* element);
	void removeElement(void* element);
	void setElementAt(void* element, long idx);
	void removeElementAt(long idx);
	void removeElements(long first, long last);
	void removeAll();
	long indexOfReference(void* element);
	void setDoCleanUp(BOOL yesNo);
private:
	void init(long size, long grow);
	void shrink();
	void grow();
	void deleteAll();
};

class PGStack : public PGVector {
public:
    void push(void* element);
    void* pop();
};

#endif
