/***
 * Portable GUI
 * Code for PGDialog
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#ifndef _PGDIALOG_
#define _PGDIALOG_

#define PGDIALOG_OK		0
#define PGDIALOG_CANCEL		1

class PGDialog : public PGWindow {
public:
	PGWindow* m_hParent;
public:
	PGDialog(PGWindow* parent);
	PGDialog(PGWindow* parent, char* title);
	PGDialog(PGWindow* parent, char* title, BOOL sizable);
	virtual ~PGDialog();
	virtual void pack();
	virtual void toString(PGString* str);
	virtual void notifyWindowListeners(int notify);
	void doModal();
private:
	void init(PGWindow* parent, char *title, BOOL sizable);
};

class PGDialogCancelListener : public PGActionListener {
public:	
	PGDialog* m_hDialog;
public:
	PGDialogCancelListener(PGDialog* dialog);
	void actionPerformed(PGActionListenerParent* parent);	
};

#endif
