/***
 * Portable GUI
 * Code for PGFrame
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#ifndef _PGFRAME_
#define _PGFRAME_

#define PGFRAME_STATE_ICONIFIED	0
#define PGFRAME_STATE_NORMAL	1

class PGFrame : public PGWindow {

	#ifdef PGGTK
		#include <pgdep/gtk/pggtkchild.h>
	#endif

public:
	PGFrame();
	PGFrame(char *);
	PGFrame(char *title, BOOL sizable);
	virtual ~PGFrame();
	virtual void toString(PGString* str);
	int getState();
	void setState(int state);
public:
	#ifdef PGMENU
		PGMenuBar* m_pMenuBar;
		void setMenuBar(PGMenuBar* menu);
		PGMenuBar* getMenuBar();
	#endif
private:
	void init(char *, BOOL sizable);
};
 
#endif
