/***
 * Portable GUI
 * Code for PortableGUI
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef _PGINCLUDE_
#define _PGINCLUDE_

#define STR(a) PGString(a)

#include <pgmain/pgmain.h>
#include <pgmain/pgmath.h>

#include <pgutil/pgstring.h>
#include <pgutil/pgcollection.h>
#include <pgutil/pglinkedlist.h>
#include <pgutil/pgvector.h>

#include <pgcomponent/pgactionlistener.h>

#ifndef PGTINY
	#include <pgutil/pgrandom.h>
	#include <pgcomponent/pgmouselistener.h>

	#ifdef PGGTK
		#include <pgdep/gtk/pggtklayobox.h>
		#include <pgdep/gtk/pggtkcanvas.h>
	#endif

	#ifdef PGBEOS
		#include <pgdep/beos/pgbeoslayobox.h>
	#endif

	#include <pgdraw/pgfont.h>
	#include <pgcomponent/pgstyle.h>

	#include <pgio/pginputstream.h>
	#include <pgio/pgmeminputstream.h>	
	
	#include <pgio/pgfileinputstream.h>
	#include <pgio/pgfileoutputstream.h>	
	
	#ifdef PGFILE
		#include <pgio/pginifile.h>
	#endif
	
	#ifdef PGSHAPE
		#include <pgdraw/pgshape.h>
	#endif
	
	#include <pgdraw/pgcolor.h>
	#include <pgdraw/pgfontmetrics.h>
	#include <pgdraw/pggraphics.h>			
#endif

#ifdef PGMENU
	#include <pgcomponent/pgmenu.h>
#endif

#include <pgcomponent/pgcomponent.h>
#include <pgcomponent/pgcontainer.h>
#include <pglayout/pglayoutmanager.h>
#include <pgcomponent/pgnormalcontainer.h>
#include <pgmain/pgapplication.h>
#include <pgwindow/pgwindowlistener.h>
#include <pgwindow/pgwindow.h>
#include <pgwindow/pgframe.h>

#ifndef PGTINY
	#include <pglayout/pgborderlayout.h>
	#include <pglayout/pgpercentlayout.h>

	#include <pgcomponent/pgnormalcomponent.h>

	#include <pgcomponent/pgtextcomponent.h>
	#include <pgcomponent/pgtextarea.h>

	#include <pgcomponent/pgbutton.h>
	#include <pgcomponent/pglabel.h>
	#include <pgcomponent/pgpanel.h>

	#include <pgcomponent/pgupdown.h>

	#include <pgwindow/pgdialog.h>

	#include <pgmain/pgclipboard.h>

	#include <pgdialog/pgfiledialog.h>
	#include <pgdialog/pgmessagebox.h>

	#include <pgdraw/pgimage.h>
	#include <pgcomponent/pgcanvas.h>
	#include <pgcomponent/pgimageviewer.h>		
	#include <pgcomponent/pganimatedimgviewer.h>
#endif

#ifdef PGGIF
	#include <pgdraw/pggif.h>
#endif

#ifdef PGBMP
	#include <pgdraw/pgbmp.h>
#endif

#endif

