/***
 * Portable GUI
 * Code for PGFileDialog
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <portablegui.h>

static gboolean PGOnFileOK(GtkWidget *widget, gpointer data) {
	PGFileDialog* file = (PGFileDialog*)data;
	// Return values
	file->m_bWasOK = TRUE;
	gchar* name = gtk_file_selection_get_filename(GTK_FILE_SELECTION(file->m_hWidget));
	file->m_sFile.setCopyValue(name);
	// And go home
	gtk_widget_destroy(file->m_hWidget);
	return FALSE;
}

static gboolean PGOnFileClose(GtkWidget *widget, gpointer data) {
	gtk_main_quit ();
	return FALSE;
}
 
BOOL PGFileDialog::showFileOpenDialog(PGWindow* parent) {
	if (m_sFilter.getLength() == 0) setFilter("All files (*.*)$*.*$");
	//if (m_bUseDirectory) {
	//	m_sDirectory.getValue();
	//}
	// Create file selection
        m_hWidget = gtk_file_selection_new(m_sTitle.getValue());
        gtk_file_selection_set_filename(GTK_FILE_SELECTION(m_hWidget), m_sFile.getValue());
	// Set modal
	gtk_window_set_modal(GTK_WINDOW(m_hWidget), TRUE);
	gtk_window_set_transient_for(GTK_WINDOW(m_hWidget), GTK_WINDOW(parent->m_hWidget));
	// Connect signals
	gtk_signal_connect(GTK_OBJECT(m_hWidget),"destroy",GTK_SIGNAL_FUNC(PGOnFileClose),(gpointer)this);
	gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(m_hWidget)->ok_button),"clicked",GTK_SIGNAL_FUNC(PGOnFileOK),(gpointer)this);
	gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(m_hWidget)->cancel_button),"clicked",GTK_SIGNAL_FUNC(gtk_widget_destroy),GTK_OBJECT(m_hWidget));
        // Show
        gtk_widget_show(m_hWidget);
	gtk_main();
	return m_bWasOK;
}

BOOL PGFileDialog::showFileSaveDialog(PGWindow* parent) {
	return PGFileDialog::showFileOpenDialog(parent);
}
