/***
 * Portable GUI
 * Code for PGFrame
 * Copyright (C) 2000-2000 LittlePanda <littlepanda@mostlysunny.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#include <portablegui.h>

// subclassing BWindow
class PGBeWindow: public BWindow
{
	public: 
		PGBeWindow(BRect frame, char *title);
		~PGBeWindow(void);
		bool QuitRequested(void);		

		PGFrame* pgframe;
};

// PG-Method invoked when the close button is pressed.
bool PGOnDeleteEvent(PGFrame* pgframe);

PGBeWindow::PGBeWindow(BRect frame, char *title): BWindow(frame, title, B_TITLED_WINDOW,0) {
}

PGBeWindow::~PGBeWindow(void) {
}

bool PGBeWindow::QuitRequested(void) {
	be_app->PostMessage(B_QUIT_REQUESTED);
	PGFrame* frame = this->pgframe;
	return(TRUE);
}

void PGFrame::setState(int state) {
}

void PGFrame::init(char *str, BOOL sizable) {
	// Init data members
#ifndef PGTINY
	m_pMenuBar = (PGMenuBar*)NULL;
#endif
	// Create main window
	BRect MyBeFrame(597,356,901,483);
	m_hWindow = new PGBeWindow(MyBeFrame, str);
	if (!sizable) m_hWindow->SetFlags(B_NOT_RESIZABLE);
	((PGBeWindow*) m_hWindow)->pgframe = this;
#ifndef PGTINY
	m_hPGContainer = pg_gtk_layobox_new();
	pg_gtk_layobox_set_pgcontainer(PG_GTK_LAYOBOX(m_hPGContainer), this);
	gtk_box_pack_end(GTK_BOX(vbox), m_hPGContainer, TRUE, TRUE, 0);
#endif
	
}
