/***
 * Portable GUI
 * Code for PGFrame
 * Copyright (C) 2000-2000 LittlePanda <littlepanda@mostlysunny.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#include <portablegui.h>

// PG-Method invoked when the close button is pressed.
bool PGOnDeleteEvent(PGFrame* pgframe);

void PGWindow::dispose() {
	m_hWindow->Quit();
}

void PGWindow::getPreferredSize(PGDimension* dimension, BOOL recalc) {
	PGNormalContainer::getPreferredSize(dimension, recalc);
}

void PGWindow::getTitle(PGString* title) {
	title->setCopyValue((char *)m_hWindow->Title());
}

void PGWindow::setTitle(char* str) {
	m_hWindow->SetTitle(str);
}

void PGWindow::pack() {
	addToWindow(this);
}

bool PGOnDeleteEvent(PGFrame* pgframe) {
	PGWindow* myWindow = (PGWindow*) pgframe;
	myWindow->notifyWindowListeners(PGWINDOW_CLOSING);
	return TRUE;
}

