/***
 * Portable GUI
 * Code for PGFocusListener
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */


#include <pgcomponent/pgfocuslistener.h>

PGFocusListener::~PGFocusListener() {
}
 
void PGFocusListener::toString(PGString* str) {
	PGObject::toString(str);
	str->substring(8);	
	str->prepend("PGFocusListener ");
}

// Invoked when a component gains the keyboard focus
void PGFocusListener::focusGained(PGComponent* comp) {
}

// Invoked when a component loses the keyboard focus
void PGFocusListener::focusLost(PGComponent* comp) {
}
 
void PGFocusListenerParent::onFocusGained(PGComponent* comp) {	
	for (PGFocusListener* focus = (PGFocusListener*)m_hFocusListeners.getFirst(); focus != NULL; ) {
		focus->focusGained(comp);
		focus = (PGFocusListener*)focus->getNextElement();
	}
}

void PGFocusListenerParent::onFocusLost(PGComponent* comp) {	
	for (PGFocusListener* focus = (PGFocusListener*)m_hFocusListeners.getFirst(); focus != NULL; ) {
		focus->focusLost(comp);
		focus = (PGFocusListener*)focus->getNextElement();
	}
}

PGFocusListenerParent::~PGFocusListenerParent() {
}

void PGFocusListenerParent::addFocusListener(PGFocusListener* focus) {
	m_hFocusListeners.add(focus);
}

void PGFocusListenerParent::removeFocusListener(PGFocusListener* focus) {
	//m_hFocusListeners.remove(focus);
}


