/***
 * Portable GUI
 * Code for PGImageViewer
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <portablegui.h>

PGImageViewer::PGImageViewer(PGImage* image) {
	m_hImage = image;
	PGINCREF(image);
}

PGImageViewer::~PGImageViewer() {
	if (m_hImage != NULL) PGDECREF(m_hImage);
}

void PGImageViewer::paint(PGGraphics* graph) {
	PGDimension dim;
	getSize(&dim);
	//int xpos = dim.width/2 - m_hImage->m_iCols/2;
	//int ypos = dim.height/2 - m_hImage->m_iRows/2;		
	int xpos = 0;
	int ypos = 0;
	if (!m_hImage->hasError())  {
		graph->drawImage(m_hImage, xpos, ypos);		
	}
}

void PGImageViewer::getPreferredSize(PGDimension* dimension, BOOL recalc) {
	dimension->width = m_hImage->m_iCols;
	dimension->height = m_hImage->m_iRows;
}
