/***
 * Portable GUI
 * Code for PGButton
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <portablegui.h>

PGLabel::PGLabel(const char* label) : PGNormalComponent() {
	init(label, PGLABEL_LEFT);
}

PGLabel::PGLabel(const char *label, PGStyle* style) : PGNormalComponent() {
	init(label, PGLABEL_LEFT);
	setStyle(style);
}

PGLabel::PGLabel(const char* label, int flags) : PGNormalComponent() {
	init(label, flags);
}

void PGLabel::toString(PGString* str) {
	PGObject::toString(str);
	str->substring(8);
	str->prepend(m_sLabel.getValue());
	str->prepend("PGLabel ");
}

void PGLabel::init(const char* label, int flags) {
	m_sLabel.setCopyValue(label);
	m_iFlags = (m_iFlags & 0xFF) | flags;
}
