/***
 * Portable GUI
 * Code for PGTextArea
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <portablegui.h>

PGTextArea::PGTextArea(const char* str, int rows, int cols, int scrollbar) {
	m_iScrollBar = scrollbar;
	m_sText.append(str, FALSE);
	m_iCols = cols;
	m_iRows = rows;
}

void PGTextArea::toString(PGString* str) {
	PGObject::toString(str);
	str->substring(8);
	str->prepend("PGTextArea");
}

void PGTextArea::append(const char* str) {
	append(str, TRUE);
}

// Sets the number of columns for this text area.
void PGTextArea::setColumns(int columns) {
	m_iCols = columns;
}

// Sets the number of rows for this text area.
void PGTextArea::setRows(int rows) {
	m_iRows = rows;
}

