/***
 * Portable GUI
 * Code for PGFileDialog
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <portablegui.h>

PGFileDialog::PGFileDialog(const char* title) {
	m_sTitle.setCopyValue(title);
	m_bUseDirectory = FALSE;
	m_bWasOK = FALSE;
}

void PGFileDialog::setTitle(const char* title) {
	m_sTitle.setCopyValue(title);
}

void PGFileDialog::setDirectory(const char* directory) {
	if (directory != NULL) {
		m_sDirectory.setCopyValue(directory);
		m_bUseDirectory = TRUE;
	} else {
		m_bUseDirectory = FALSE;
	}
}

void PGFileDialog::setFilter(const char* filter) {
	m_sFilter.setCopyValue(filter);
	m_sFilter.replace('$', 0);
}

void PGFileDialog::setFile(const char* file) {
	m_sFile.setCopyValue(file);
}
