/***
 * Portable GUI
 * Code for PGButton
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <portablegui.h>

// Determines the font ascent
int PGFontMetrics::getAscent() {
	return m_iAscent;
}

// Determines the font descent
int PGFontMetrics::getDescent() {
	return m_iDescent;
}

// Gets the standard height of a line of text
int PGFontMetrics::getHeight() {
	return m_iHeight;
}

// Determines the standard leading
int PGFontMetrics::getLeading() {
	return m_iLeading;
}

// Gets the maximum advance width of any character
int PGFontMetrics::getMaxAdvance() {
	return m_iMaxAdvance;
}

// Determines the maximum ascent
int PGFontMetrics::getMaxAscent() {
	return m_iMaxAscent;
}

// Determines the maximum descent
int PGFontMetrics::getMaxDescent() {
	return m_iMaxDescent;
}

// Returns the total advance width for showing the specified String
int PGFontMetrics::stringWidth(PGString* str) {
	PGDimension dim;
	getStringSize(str, &dim);
	return dim.width;
}
