/***
 * Portable GUI
 * Code for PGShape
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#include <pgdraw/pgshape.h>

PGPolygon::PGPolygon() {
	init(0);
}

PGPolygon::PGPolygon(int nPoints) {
	init(nPoints);		
}

PGPolygon::PGPolygon(int* xPoints, int* yPoints, int nPoints) {	
	init(nPoints);		
	for (int ctr = 0; ctr < nPoints; ctr++) {
		m_iXPoints[ctr] = xPoints[ctr];
		m_iYPoints[ctr] = yPoints[ctr];
	}
	m_iNPoints = nPoints;
}

PGPolygon::~PGPolygon() {
	unrealize();
	if (m_iXPoints != NULL) delete m_iXPoints;
	if (m_iYPoints != NULL) delete m_iYPoints;
}

// FIXME: Poly must grow
void PGPolygon::addPoint(int x, int y) {
	if (m_iNPoints >= m_iSize) {
		
		
	} else {
		m_iXPoints[m_iNPoints] = x;
		m_iYPoints[m_iNPoints] = y;
		m_iNPoints++;	
	}
	m_bRealized = FALSE;
}

int PGPolygon::getNbPoints() {
	return m_iNPoints;
}

void PGPolygon::init(int size) {
	m_bRealized = FALSE;
	if (size == 0) {
		m_iXPoints = (int*)NULL;
		m_iYPoints = (int*)NULL;
	} else {
		m_iXPoints = new int[size];
		m_iYPoints = new int[size];
	}
	m_iNPoints = 0;
	m_iSize = size;
	init();
}

void PGRectangle::fromPoints(int x1, int y1, int x2, int y2) {
	x      = PGMathMin(x1, x2);
	y      = PGMathMin(y1, y2);
	width  = PGMathAbs(x1-x2);
	height = PGMathAbs(y1-y2);
}
