/***
 * Portable GUI
 * Code for PGInputStream
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#include <pgio/pgmeminputstream.h>

PGMemoryInputStream::PGMemoryInputStream(const unsigned char* data, int size) {
	m_hMemory = data;
	m_iPos = 0;
	m_iSize = size;
}

int PGMemoryInputStream::getError() {
	return PGINPUTSTREAM_ERROR_NONE;
}

// Reads the next byte of data from the input stream
int PGMemoryInputStream::read() {
	if (m_iPos >= m_iSize) return -1;
	else return (int)m_hMemory[m_iPos++];
}

// Reads up to len bytes of data from the input stream into an array of bytes
int PGMemoryInputStream::read(unsigned char* buffer, int off, int len) {
	int nb = m_iSize - m_iPos;
	if (nb > len) nb = len;
	memcpy(buffer+off, m_hMemory+m_iPos, nb);
	m_iPos += nb;
	return nb;
}
