
#include <pgutil/pglinkedlist.h>

PGListElement::PGListElement() {
	m_hNextElement = NULL;
}

PGListElement* PGListElement::getNextElement() const {
	return m_hNextElement;
}

void PGListElement::setNextElement(PGListElement* elem) {
	m_hNextElement = elem;
}

PGAbstractLinkedList::PGAbstractLinkedList() {
	m_hFirstElement = NULL;
	m_hLastElement = NULL;
}

PGAbstractLinkedList::~PGAbstractLinkedList() {
	clear();
}

boolean PGAbstractLinkedList::add(PGObject* o) {
	PGListElement* elem = (PGListElement*)o;
	if (m_hFirstElement == NULL) m_hFirstElement = elem;
	else m_hLastElement->setNextElement(elem);
	m_hLastElement = elem;
	PGINCREF(o);
	return true;
}

void PGAbstractLinkedList::clear() {
	PGListElement* elem = m_hFirstElement;
	while (elem != NULL) {
		PGListElement* next = elem->getNextElement();
		PGDECREF(elem);
		elem = next;
	}
	m_hFirstElement = NULL;
	m_hLastElement = NULL;
}

void PGAbstractLinkedList::addFirst(PGObject* o) {
}

void PGAbstractLinkedList::addLast(PGObject* o) {
	add(o);
}

PGListElement* PGAbstractLinkedList::getFirst() const {
	return m_hFirstElement;
}

PGIterator PGAbstractLinkedList::iterator() {
	return PGIterator(this, m_hFirstElement);
}

boolean PGAbstractLinkedList::hasNext(int idx, PGObject* obj) const {
	if (obj == null) return false;
	PGListElement* elem = (PGListElement*)obj;
	return elem->getNextElement() != null;
}

PGObject* PGAbstractLinkedList::next(int idx, PGObject* obj) const {
	PGListElement* elem = (PGListElement*)obj;
	return elem->getNextElement();
}
