/***
 * Portable GUI
 * Code for PGFrame
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#include <portablegui.h>

PGDialog::PGDialog(PGWindow* parent) {
	init(parent, "", TRUE);
}

PGDialog::PGDialog(PGWindow* parent, char *title) {
    	init(parent, title, TRUE);
}

PGDialog::PGDialog(PGWindow* parent, char *title, BOOL sizable) {
	init(parent, title, sizable);
}

PGDialog::~PGDialog() {
}

void PGDialog::toString(PGString* str) {
	PGObject::toString(str);
	str->substring(8);
	str->prepend("PGDialog");
}

PGDialogCancelListener::PGDialogCancelListener(PGDialog* dialog) {	
	m_hDialog = dialog;
}

void PGDialogCancelListener::actionPerformed(PGActionListenerParent* parent) {			
	m_hDialog->dispose();
}

