/***
 * Portable GUI
 * Code for PGFrame
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#include <portablegui.h>

PGFrame::PGFrame() {
	init("", TRUE);
}

PGFrame::PGFrame(char *title) {
    	init(title, TRUE);
}

PGFrame::PGFrame(char *title, BOOL sizable) {
	init(title, sizable);
}

PGFrame::~PGFrame() {
#ifdef PGMENU
	if (m_pMenuBar != NULL) PGDECREF(m_pMenuBar);
#endif
}

void PGFrame::toString(PGString* str) {
	PGObject::toString(str);
	str->substring(8);
	str->prepend("PGFrame");
}

int PGFrame::getState() {
	return m_bIconified;
}

#ifdef PGMENU
	void PGFrame::setMenuBar(PGMenuBar* bar) {
		if (m_pMenuBar != NULL) {
			m_pMenuBar->removeFromFrame(this);
			PGDECREF(m_pMenuBar);
		}
		m_pMenuBar = bar;
		m_pMenuBar->addToFrame(this);
		PGINCREF(bar);
	}
	
	PGMenuBar* PGFrame::getMenuBar() {
		return m_pMenuBar;
	}
#endif
