/***
 * Portable GUI
 * Code for PGApplication
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <portablegui.h>
#include <stdarg.h>

PGApplication::~PGApplication() {
}

void PGApplication::exit(int code) {
	gtk_main_quit();
}

void PGApplication::println(const char* strg) {
	if (m_bConsoleEnabled) printf("%s\n", strg);
}

void PGApplication::printf(const char* format, ...) {
	if (m_bConsoleEnabled) {
		va_list ap;
		va_start(ap, format);
                vprintf(format, ap);
		va_end(ap);
	}
}

void PGApplication::setConsoleEnabled(BOOL enable) {
	if (m_bConsoleEnabled != enable) m_bConsoleEnabled = enable;
}

int PGApplication::run() {
	gtk_main();
	return 0;
}

void PGApplication::init(int *argc, char **argv[]) {
	gtk_init(argc, argv);
	gdk_rgb_init();
	gtk_widget_set_default_colormap(gdk_rgb_get_cmap());
	gtk_widget_set_default_visual(gdk_rgb_get_visual());
	setPGApplication(this);
}


