/***
 * Portable GUI
 * Code for PGTimer
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <portablegui.h>

static gint PGTimerCallback(gpointer data) {
	PGTimer* timer = (PGTimer*)data;								
	timer->tick();
	return timer->isRunning() ? 1 : 0;
}

void PGTimer::startTimer(long delay) {
	m_iDelay = delay;	
	m_iTimerTag = gtk_timeout_add((guint32) delay, (GtkFunction)PGTimerCallback, (gpointer)this);
}

void PGTimer::stopTimer() {
	if (m_iDelay != -1) {
		m_iDelay = -1;	
		gtk_timeout_remove(m_iTimerTag);
	}
}

void PGTimer::init() {
}

void PGTimer::term() {
}
