/***
 * Portable GUI
 * Code for PGFrame
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#include <portablegui.h>

void PGOnDestroyWindow(GtkWidget* widget, gpointer data);
gint PGOnDeleteEvent(GtkWidget* widget, GdkEvent* event, gpointer data);
#ifndef PGTINY
	gint PGOnExposeEvent(GtkWidget *widget, GdkEventExpose *event, gpointer data);
#endif

void PGFrame::setState(int state) {
/*	if (state == PGFRAME_STATE_ICONIFIED) {
		if (!m_bIconified) ShowWindow(m_hWnd, SW_MINIMIZE);
	} else {
		if (m_bIconified) ShowWindow(m_hWnd, SW_RESTORE);
	}	*/
}

void PGFrame::init(char* str, BOOL sizable) {
	// Init data members
#ifdef PGMENU
	m_pMenuBar = (PGMenuBar*)NULL;
#endif
	// Create main window
	m_hWidget = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(m_hWidget), str);
	if (sizable) gtk_window_set_policy(GTK_WINDOW(m_hWidget), FALSE, TRUE, FALSE);
	else gtk_window_set_policy(GTK_WINDOW(m_hWidget), FALSE, FALSE, TRUE);
	// Add event listeners
	gtk_signal_connect(GTK_OBJECT(m_hWidget), "destroy", GTK_SIGNAL_FUNC(PGOnDestroyWindow), (gpointer)this);
	gtk_signal_connect(GTK_OBJECT(m_hWidget), "delete_event", GTK_SIGNAL_FUNC(PGOnDeleteEvent), (gpointer)this);
	// Add VBOX for Menu
	GtkWidget *vbox = m_hChild = gtk_vbox_new(FALSE, 0);
#ifndef PGTINY
	m_hPGContainer = pg_gtk_layobox_new();
	pg_gtk_layobox_set_pgcontainer(PG_GTK_LAYOBOX(m_hPGContainer), this);
	gtk_box_pack_end(GTK_BOX(vbox), m_hPGContainer, TRUE, TRUE, 0);
//	gtk_signal_connect(GTK_OBJECT(m_hPGContainer), "expose_event", GTK_SIGNAL_FUNC(PGOnExposeEvent), (gpointer)this);	
#endif
	gtk_container_add(GTK_CONTAINER(m_hWidget), vbox);
	gtk_widget_show(vbox);
	gtk_widget_realize(m_hWidget);
}
