/***
 * Portable GUI
 * Code for PGButton
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <portablegui.h>

void PGCanvas::addToWindow(PGWindow* parent) {
	DWORD dwStyle = WS_CHILD;	
	m_hWnd = CreateWindow("pgcanvaswnd", "", dwStyle,
                         CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
                         parent->m_hWnd, (HMENU)-1, getPGApplication()->m_hInst, NULL);			      
	PGNormalComponent::addToWindow(parent);
}

void PGCanvas::removeFromWindow(PGWindow* parent) {
	PGNormalComponent::removeFromWindow(parent);
	if (m_hWnd != NULL) DestroyWindow(m_hWnd);
}

void PGCanvas::setBounds(int x, int y, int w, int h) {
	PGNormalComponent::setBounds(x, y, w, h);
	RECT rect;
	rect.left = 0;
	rect.top = 0;
	rect.right = w;
	rect.bottom = h;
	InvalidateRect(m_hWnd, &rect, FALSE);
}
