/***
 * Portable GUI
 * Code for PGFrame
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#include <portablegui.h>

PGNormalContainer::PGNormalContainer() {
	m_hWnd = NULL;
}

void PGNormalContainer::setVisible(BOOL visible) {
	ShowWindow(m_hWnd, visible ? SW_SHOW : SW_HIDE);
	PGContainer::setVisible(visible);
}

void PGNormalContainer::setBounds(int x, int y, int w, int h) {
	MoveWindow(m_hWnd,x,y,w,h,TRUE);
}

void PGNormalContainer::getBounds(PGRectangle* rectangle) {
	RECT rect;
	GetWindowRect(m_hWnd, &rect);
	rectangle->x = rect.left;
	rectangle->y = rect.top;
	rectangle->width = rect.right-rect.left;
	rectangle->height = rect.bottom-rect.top;
}

void PGNormalContainer::repaint() {
	InvalidateRect(m_hWnd,NULL,TRUE);
}

void PGNormalContainer::updateLayout() {
	PGDimension dim;
	getPreferredSize(&dim, TRUE);
	doLayout();
}

void PGNormalContainer::doLayout() {
	RECT rect;
	GetClientRect(m_hWnd, &rect);
	PGRectangle pg_rect;
	pg_rect.x = rect.top; pg_rect.y = rect.left;
	pg_rect.width = rect.right-rect.left;
	pg_rect.height = rect.bottom-rect.top;
	setLayoutSize(&pg_rect);
}