/***
 * Portable GUI
 * Code for PGFileDialog
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <portablegui.h>
 
void PGFileDialogFillStruct(HWND hWnd, PGFileDialog* dial, OPENFILENAME* opf) {
	if (dial->m_sFilter.getLength() == 0) dial->setFilter("All files (*.*)$*.*$");
	dial->m_sFile.growToSize(PGFILENAMELEN);
	opf->lStructSize = sizeof(OPENFILENAME);
	opf->hwndOwner = hWnd;
	opf->hInstance = getPGApplication()->m_hInst;
	opf->lpstrFilter = dial->m_sFilter.getValue();
	opf->lpstrCustomFilter = NULL;
	opf->nMaxCustFilter = 0;
	opf->nFilterIndex = 1;
    	opf->lpstrFile = dial->m_sFile.getBuffer();
	opf->nMaxFile = PGFILEDIALOG_MAXFILENAME;
    	opf->lpstrFileTitle = NULL;
    	opf->nMaxFileTitle = 0;
		if (dial->m_bUseDirectory) opf->lpstrInitialDir = dial->m_sDirectory.getValue();
		else opf->lpstrInitialDir = NULL;
    	opf->lpstrTitle = dial->m_sTitle.getValue();
    	opf->Flags = OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOVALIDATE;
    	opf->nFileOffset = 0;
    	opf->nFileExtension = 0;
    	opf->lpstrDefExt = NULL;
    	opf->lCustData = 0;
    	opf->lpfnHook = NULL;
    	opf->lpTemplateName = NULL;
}

BOOL PGFileDialog::showFileOpenDialog(PGWindow* parent) {
	OPENFILENAME opf;
	PGFileDialogFillStruct(parent->m_hWnd, this, &opf);
	BOOL result = GetOpenFileName(&opf);
	return result;
}

BOOL PGFileDialog::showFileSaveDialog(PGWindow* parent) {
	OPENFILENAME opf;
	PGFileDialogFillStruct(parent->m_hWnd, this, &opf);
	BOOL result = GetSaveFileName(&opf);	
	return result;	
}
