/***
 * Portable GUI
 * Code for PGMessageBox
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <portablegui.h>
 
PGMessageBox::PGMessageBox(char* title, char*message, int flags) {
	m_sTitle = title;
	m_sMessage = message;
	m_iFlags = flags;
}
	
int PGMessageBox::show(PGWindow* parent) {
	UINT flags = 0;
	if ((m_iFlags & PGMSGBOX_OK) != 0) {
		if ((m_iFlags & PGMSGBOX_CANCEL) != 0) flags |= MB_OKCANCEL;
		else flags |= MB_OK;
	}
	if ((m_iFlags & PGMSGBOX_YES) != 0 && (m_iFlags & PGMSGBOX_NO) != 0) {
		if ((m_iFlags & PGMSGBOX_CANCEL) != 0) flags |= MB_YESNOCANCEL;
		else flags |= MB_YESNO;
	}
	if ((m_iFlags & PGMSGBOX_ICONQUESTION) != 0) flags |= MB_ICONQUESTION;
	if ((m_iFlags & PGMSGBOX_ICONERROR) != 0) flags |= MB_ICONEXCLAMATION;
	int res = MessageBox(parent->m_hWnd, m_sMessage, m_sTitle, flags);
	if (res == IDOK) return PGMSGBOX_OK;
	if (res == IDYES) return PGMSGBOX_YES;
	if (res == IDNO) return PGMSGBOX_NO;
	return PGMSGBOX_CANCEL;
}

