/***
 * Portable GUI
 * Code for PGButton
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <portablegui.h>

void PGFontMetrics::getStringSize(PGString* str, PGDimension* dim) {
	SIZE size;
	GetTextExtentPoint32(m_hGraphics->m_hDC, str->getValue(), str->getLength(), &size);
	dim->width = size.cx;
	dim->height = size.cy;
}

void PGFontMetrics::realize() {
	TEXTMETRIC tm;
	GetTextMetrics(m_hGraphics->m_hDC, &tm);
	m_iHeight = tm.tmHeight;
	m_iMaxAscent = m_iAscent = tm.tmAscent;
	m_iMaxDescent = m_iDescent = tm.tmDescent;
	m_iLeading = tm.tmInternalLeading + tm.tmExternalLeading;
	m_iMaxAdvance = tm.tmMaxCharWidth;
}
