/***
 * Portable GUI
 * Code for PGButton
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <portablegui.h>

void PGRealizedFontFindFontName(PGString* name, char* dest);

void PGRealizedFont::realize(PGWindow* window) {
	HDC hDC = GetDC(window->m_hWnd);
	LOGFONT* lf = new LOGFONT;
	lf->lfHeight = -MulDiv(m_hFont->m_iSize, GetDeviceCaps(hDC, LOGPIXELSY), 72);
	lf->lfWidth = 0;
	lf->lfEscapement = 0;
	lf->lfWeight = (m_hFont->m_iFlags & PGFONT_BOLD) == 0 ? FW_NORMAL : FW_BOLD;
	lf->lfItalic = (m_hFont->m_iFlags & PGFONT_ITALIC) != 0;
	lf->lfUnderline = (m_hFont->m_iFlags & PGFONT_UNDERLINE) != 0;
	lf->lfStrikeOut = (m_hFont->m_iFlags & PGFONT_STRIKEOUT) != 0;
	lf->lfCharSet = DEFAULT_CHARSET;
	lf->lfOutPrecision = OUT_DEFAULT_PRECIS;
	lf->lfClipPrecision = CLIP_DEFAULT_PRECIS;
	lf->lfQuality = DEFAULT_QUALITY;
	lf->lfPitchAndFamily = DEFAULT_PITCH | FF_DONTCARE;
	PGRealizedFontFindFontName(&m_hFont->m_sName, lf->lfFaceName);
	
	char s[100];
	sprintf(s, "Realizing font '%s' from '%s' [%d]", lf->lfFaceName, m_hFont->m_sName.getValue(),m_hFont->m_iSize);
	getPGApplication()->println(s);
	
	m_hWFont = CreateFontIndirect(lf);
	delete lf;
	ReleaseDC(window->m_hWnd, hDC);
}

void PGRealizedFontFindFontName(PGString* name, char* dest) {
	if (name->charAt(0) == '$') {
		name->copyRange(1, -1, dest);		
	} else {
		if (name->equals("Dialog")) strcpy(dest, "MS Sans Serif");			
		else if (name->equals("System")) strcpy(dest, "System");
		else if (name->equals("Times")) strcpy(dest, "Times New Roman");
		else strcpy(dest, "");		
	}		
}

void PGRealizedFont::unrealize() {	
	DeleteObject(m_hWFont);	
}
