/***
 * Portable GUI
 * Code for PGShape
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#include <pgdraw/pgshape.h>
 
// Internals
void PGPolygon::realize() {
	if (!m_bRealized) {
		if (m_hWinPoints != NULL) delete m_hWinPoints;
		m_hWinPoints = new POINT[m_iNPoints];
		for (int ctr = 0; ctr < m_iNPoints; ctr++) {
			m_hWinPoints[ctr].x = m_iXPoints[ctr];
			m_hWinPoints[ctr].y = m_iYPoints[ctr];
		}				
		m_bRealized = TRUE;
	}
}

void PGPolygon::unrealize() {
	if (m_hWinPoints != NULL) {
		delete m_hWinPoints;
		m_hWinPoints = (POINT*)NULL;
	}		
	m_bRealized = FALSE;	
}

void PGPolygon::init() {
	m_hWinPoints = (POINT*)NULL;
}

