/***
 * Portable GUI
 * Code for PGClipboard
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <portablegui.h>

void PGClipBoard::open(PGWindow* owner) {
	OpenClipboard(owner->m_hWnd);
}

void PGClipBoard::close() {
	CloseClipboard();
}

void PGClipBoard::empty() {
	EmptyClipboard();
}

void PGClipBoard::setText(PGString* str) {
	DWORD len = str->getLength()+1;
	HGLOBAL hData = GlobalAlloc(GMEM_MOVEABLE | GMEM_DDESHARE, len);
	char* data = (char*)GlobalLock(hData);
	if (data != NULL) strcpy(data, str->getValue());
	GlobalUnlock(hData);
	SetClipboardData(CF_TEXT, hData);
}

BOOL PGClipBoard::getText(PGString* str) {
	BOOL result = FALSE;
	HGLOBAL hData = GetClipboardData(CF_TEXT);
	if (hData == NULL) return FALSE;
	char* data = (char*)GlobalLock(hData);
	if (data != NULL) {
		int len = strlen(data);
		str->allocateNew(len);
		strcpy(str->getValue(), data);
		result = TRUE;
	}
	GlobalUnlock(hData);
	return result;
}
