/***
 * Portable GUI
 * Code for PGTimer
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <pgutil/pgtimer.h>
#include <pgwindow/pgwindow.h>
#include <pgmain/pgapplication.h>

void PGTimerTick(PGTimer* timer) {
	timer->tick();	
}

void PGTimer::init() {
	m_iId = getPGApplication()->m_vOtherIDList.registerObject(this);
}

void PGTimer::term() {
	if (m_iId != -1) getPGApplication()->m_vOtherIDList.freeCommand(m_iId);
}

void PGTimer::startTimer(long delay) {
	m_iDelay = delay;
	SetTimer(m_hOwner->m_hWnd, m_iId, delay, NULL);
}

void PGTimer::stopTimer() {
	if (m_iDelay != -1) {
		m_iDelay = -1;
		KillTimer(m_hOwner->m_hWnd, m_iId);
	}
}

