/***
 * Portable GUI
 * Code for PGFrame
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#include <portablegui.h>

void PGDialog::init(PGWindow* parent, char *str, BOOL sizable) {
	// Remember parent
	m_hParent = parent;
	// Create main window
	DWORD dwStyle = sizable ? WS_OVERLAPPEDWINDOW : WS_OVERLAPPED | WS_SYSMENU;
	m_hWnd = CreateWindow("pgframewnd", str, dwStyle,
                         CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
                         parent->m_hWnd, (HMENU) NULL, getPGApplication()->m_hInst, (LPSTR) NULL);
	// Remember pointer to this
    	SetWindowLong(m_hWnd, GWL_USERDATA, (LONG)this);
}

void PGDialog::doModal() {
	MSG msg;
	setVisible(TRUE);
	EnableWindow(m_hParent->m_hWnd, FALSE);
    	while (GetMessage (&msg, NULL, 0, 0)) {
        	TranslateMessage (&msg);
        	DispatchMessage (&msg);
    	}
}

void PGDialog::notifyWindowListeners(int notify) {
	PGWindow::notifyWindowListeners(notify);
	if (notify == PGWINDOW_CLOSED) {
		PostQuitMessage(0);
		EnableWindow(m_hParent->m_hWnd, TRUE);
		SetActiveWindow(m_hParent->m_hWnd);
	}
}

void PGDialog::pack() {
	PGDimension pref;
	PGRectangle rect;
	addToWindow(this);
	getPreferredSize(&pref, TRUE);
	m_hParent->getBounds(&rect);
	setBounds(rect.x+rect.width/2-pref.width/2,
		rect.y+rect.height/2-pref.height/2, pref.width, pref.height);
}

