/***
 * Portable GUI
 * Code for PGFrame
 * Copyright (C) 2000-2000 Jan Struyf <jan.struyf@cs.kuleuven.ac.be>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#include <portablegui.h>

void PGFrame::setState(int state) {
	if (state == PGFRAME_STATE_ICONIFIED) {
		if (!m_bIconified) ShowWindow(m_hWnd, SW_MINIMIZE);
	} else {
		if (m_bIconified) ShowWindow(m_hWnd, SW_RESTORE);
	}
}

void PGFrame::init(char *str, BOOL sizable) {
	// Init data members
#ifdef PGMENU
	m_pMenuBar = (PGMenuBar*)NULL;
#endif
	// Create main window
#ifdef PGWIN
	DWORD dwStyle = sizable ? WS_OVERLAPPEDWINDOW : WS_OVERLAPPED | WS_SYSMENU;
	m_hWnd = CreateWindow("pgframewnd", str, dwStyle,
                         CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
                         (HWND) NULL, (HMENU) NULL, getPGApplication()->m_hInst, (LPSTR) NULL);
#endif
#ifdef PGCE
	DWORD dwStyle = sizable ? WS_OVERLAPPED : WS_OVERLAPPED | WS_SYSMENU;
	m_hWnd = CreateWindow(L"pgframewnd", L"Title", dwStyle,
                         CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
                         (HWND) NULL, (HMENU) NULL, getPGApplication()->m_hInst, (LPSTR) NULL);
#endif
	// Remember pointer to this
    	SetWindowLong(m_hWnd, GWL_USERDATA, (LONG)this);
}


